// Ulsop Loader
// This loader is a DOS-Executable for use with DOS or Ulsop-BS

#define ULSOP_VERSIONSTR "Ulsop V1.0"
#define ULSOP_VERSIONMAJOR 1
#define ULSOP_VERSIONMINOR 0
#define ULSOP_KERNEL

#define MOUSEDBG

#define TASKBARAREA 20
#define USESYSTEMFKT

// Ulsop INTS:
//  FFh = Servicehandler
//  FEh = Pointer to datastruct
//  FDh = Driverlist (chained)
//  FCh = Multitasking-Int.
//  FBh = Switch-Task

// Ulsop Driver-Requests:
//  AH=Driver-ID AL=Fkt.ID
//   Function FF - Get memory and uninit (end of prg, to free)
//    Out: AX-DX: Memory Segments to free (0=Empty)
//    Out: SI: 1234h

#ifndef UCHR
 #define UCHR unsigned char
 #define UINT unsigned int
 #define ULNG unsigned long
#endif

#include "stdio.h"
#include "stdlib.h"
#include "dos.h"
#include "string.h"
#include "time.h"
// #include "lfn\lfn.h"

#ifdef USESYSTEMFKT
#define runprg(x) system(x)
#else
#include "callprg.h"        // EXEC-Fkt.
#define runprg callprg(x)
#endif

#include "ulsopini.h"       // INI-Functions

    // Data-Unions/Structs
#pragma pack(1)         // No alignment

    // Infostructs

// union adword
UINT dstr[32];
UCHR iretdata = 0xCF;
struct atask
        {
        char status;            // -1=Unused 0=Running 1=Suspended 2=terminate
        char far *taskname;     // ID for Taskbar
        UINT lastsig;           // Signals (0=None, 1=paint, 2=term)
        UINT ss,sp;             // Stack
        unsigned xres, yres, cres; // Apps X&Y&C (xres=0 if system-std)
        } tasktable[64];
UCHR runningtask=0xFF;          // 0xFF=None
UCHR fgtask=0xFF;               // 0xFF=None
UINT mycs,myds;                 // Kernel's-Segments
UCHR globi;                     // Global counter (no locals in int.fkts.)
ULNG globl;                     // Global long
UINT globa,globb,globc,globd;   // Global integers
char *globfar;                  // Same as upper
UINT strkill=0;                 // Straight kill for panics
UCHR shutdownflag=0;            // Set to 1 to shutdown os
UCHR reqtbdraw=0;               // Taskbar-Redraw requested
UCHR reqfgswitch=0;             // FG-Switch requested
UINT mousex, mousey, butti;     // Mouse-Coordinates (FFFF if no mouse)
UCHR mousepointeron;            // 0/1

#ifdef MOUSEDBG
FILE *mousedbg;
#endif

#include "videodrv.h"       // Videofkts.
#include "controls.h"
#include "taskbar.h"
#include "runuxe.h"
#include "mouse.h"
#include "minigui.h"

void removedrivers(void);

void freesomemem(UINT theseg)
    {
    _asm
        {
        mov ax, theseg
        mov es, ax
        mov ah, 49h
        int 21h
        }
    }

void freeproggie(UINT taskid)
    {
    gui_endtask(taskid);
    freesomemem(tasktable[taskid].lastsig);
    freesomemem(tasktable[taskid].ss);
    tasktable[taskid].status = -1;
    tasktable[taskid].taskname = NULL;
    tasktable[taskid].xres = 0;
    }

void cleartasktable()
    {
    int i;
    for(i=0;i<64;i++)
        tasktable[i].status = -1;
    }

    // Ulsop - Servicehandlers

void __far __interrupt swtask()
                {
                reqfgswitch = 1;
                reqtbdraw++;
                }

void dothefgswitch()
                {
                int i=0;
                globi = fgtask + 1;
                while((!(tasktable[globi].status == 0 && tasktable[globi].taskname != NULL)) && i < 8)
                    if(globi++ == 63) globi = 0, i++;
                if(i < 8)
                    {
                    if(tasktable[fgtask].xres != tasktable[globi].xres || tasktable[fgtask].yres != tasktable[globi].yres || tasktable[fgtask].cres != tasktable[globi].cres)
                        if(tasktable[globi].xres == 0)
                            setres(0);
                        else
                            setresext(0,tasktable[globi].xres,tasktable[globi].yres,tasktable[globi].cres);
                    fgtask = globi;
                    tasktable[fgtask].lastsig = 1;
                    }

                }

void __far __interrupt ulhandle()
    {
    switch(dstr[0])
        {
        case 0:         // Function 0: End Task. (1 = CS) The task will be killed next FC-Call
                if(runningtask != 0xFF)
                        {
                        tasktable[runningtask].status = 2;
                        tasktable[runningtask].lastsig = dstr[1];
                        if(fgtask == runningtask)
                            {
                            for(globi=0;globi<runningtask;globi++)
                                if(tasktable[globi].status == 0)
                                    fgtask = globi;
                            if(fgtask == runningtask)
                                for(globi=runningtask;globi<64;globi++)
                                    if(tasktable[globi].status == 0)
                                        fgtask = globi;
                            tasktable[fgtask].lastsig = 1;       // Repaint
                            reqtbdraw = 64;
                            }
                        _asm int 0xFC;
                        }
                break;
        case 1:         // Function 1: Get Task-ID (return in 1)
                dstr[1] = runningtask;
                break;
        case 2:         // Function 2: Get Foreground-Task-ID (return in 1)
                dstr[1] = fgtask;
                break;
        case 3:         // Function 3: Get last signal & clear (task-id: 1, retrun: 2)
                if(dstr[1] == 0xFF)
                        dstr[1] = runningtask;
                if(dstr[1] == 0xFF)
                        dstr[2] = 0xFF;
                else
                        {
                        dstr[2] = tasktable[dstr[1]].lastsig;
                        tasktable[dstr[1]].lastsig = 0;
                        }
                break;
        case 4:         // Function 4: Get system areas (no App-Call!)
                dstr[1] = mycs;                     // 1=Codeseg.
                dstr[2] = myds;                     // 2=Dataseg
                dstr[3] = (UINT) &runningtask;      // 3=Ptr. to running task
                dstr[4] = (UINT) &fgtask;           // 4=Ptr. to FG-Task
                dstr[5] = (UINT) tasktable;         // 5=Ptr. to Tasktable
                dstr[6] = (UINT) &shutdownflag;     // 6=Ptr. to Shutdown-Flag
                break;
        case 5:         // Function 5: Get task-data (1=id ; 2,3,4,5,6,7 = staus,segname,offname,lastsig,ss,sp)
                if(dstr[1] == 0xFF)
                    dstr[1] = runningtask;
                dstr[2] = tasktable[dstr[1]].status;
                dstr[3] = FP_SEG(tasktable[dstr[1]].taskname);
                dstr[4] = FP_OFF(tasktable[dstr[1]].taskname);
                dstr[5] = tasktable[dstr[1]].lastsig;
                dstr[6] = tasktable[dstr[1]].ss;
                dstr[7] = tasktable[dstr[1]].sp;
                break;
        case 6:         // Function 6: Undocumented (Helps assembler to switch task)
                if(reqfgswitch) dothefgswitch(), reqfgswitch = 0;
                getmousestatus(&mousex, &mousey, &butti);
                if(manmouse && manmouseon) domouse();
                if(runningtask != 0xFF)
                    {
                    tasktable[runningtask].ss = dstr[1];
                    tasktable[runningtask].sp = dstr[2];
                    globi = runningtask + 1;
                    }
                else
                        runningtask = 0;
                while(globi < 64)
                    {
                    if(tasktable[globi].status == 2) freeproggie(globi);
                    if(tasktable[globi].status == 0) goto canswitchtothis;
                    globi++;
                    }
                globi = 0;
                while(globi < 64)
                    {
                    if(tasktable[globi].status == 2) freeproggie(globi);
                    if(tasktable[globi].status == 0) goto canswitchtothis;
                    globi++;
                    }
                removedrivers();
                puts("PANIC! No task to execute");
                strkill = 1;
                dstr[0] = 0xFFFF;
                break;
canswitchtothis:
                // We've found a task, get it's stack
                runningtask = globi;
                dstr[1] = tasktable[runningtask].ss;
                dstr[2] = tasktable[runningtask].sp;
                if(reqtbdraw == 1)
                    drawthetaskbar();
                if(reqtbdraw > 0)
                    reqtbdraw--;
                break;
        case 8:         // Function 8: OS-Shutdown 1=(0: Kill & Shutdown)
                if(dstr[1] == 0)
                    shutdownflag = 1;
                break;
        case 9:         // Function 9: Kbhit? (1: >0 if yes)
                if(runningtask == fgtask)
                    dstr[1] = kbhit();
                else
                    dstr[1] = 0;
                break;
        case 0xA:       // Function A: Get char (waits if none in buffer or task inactive)
                while(!((fgtask == runningtask) && kbhit()))
                    _asm int 0xFC;
                dstr[1] = getch();
                if(dstr[1] == 0) dstr[1] = getch() * 256;
                break;
        case 0xB:       // Function B: Get setting (1,2=name ; 3,4=value)
                globfar = getentry(MK_FP(dstr[1],dstr[2]));
                dstr[3] = FP_SEG(globfar);
                dstr[4] = FP_OFF(globfar);
                break;
        case 0xC:       // Function C: Set setting (1,2,3,4 = name,value ; 5: (=0: OK))
                dstr[5] = setentry(MK_FP(dstr[1],dstr[2]), MK_FP(dstr[3],dstr[4]));
                break;
        case 0xD:       // Function D: Save settings to disk (; 1: (=0:OK))
                dstr[1] = saveini();
                break;
        case 0xE:       // Function E: Int 2 string (1,2,3,4 = num,buff,len)
                itoa(dstr[1],MK_FP(dstr[2],dstr[3]),dstr[4]);
                break;
        case 0xF:       // Function F: Execute (1,2=filename)
                runuxe(MK_FP(dstr[1],dstr[2]));
                break;
        case 0x10:      // Function 10: Get timer 1/100 sec. (; 1,2 = low,high)
                globl = clock();
                dstr[1] = globl;
                dstr[2] = globl / 65536;
        case 0x11:      // Function 11: Randomize
                dstr[2] = (UINT) ((( (long) rand()) * dstr[1]) / RAND_MAX);
                break;
        case 0x12:      // Function 12: Call DOS-Prog (1,2 = seg,off)
                system((char *) MK_FP(dstr[1],dstr[2]));
                break;
        case 0x7B:      // Function 7B: OK-Messagebox (1,2 = seg,off)
                ok_msgbox(MK_FP(dstr[1],dstr[2]));
                break;
        case 0x7C:      // Function 7C: Get rect for splitted screen (6,7,8,9 = x-piece,y-piece,x-size,y-size; 2,3,4,5 = x1,y1,x2,y2)
                dstr[2] = dstr[6] * dstr[8];
                dstr[3] = dstr[7] * dstr[9];
                dstr[4] = dstr[2] + dstr[8] - 1;
                dstr[5] = dstr[3] + dstr[9] - 1;
                break;
        case 0x7D:      // Function 7D: Split screen into pieces (1,2,3,4 = x-pieces,y-pieces,x-reserve,y-reserve ; 5,6 = x-size,y-size)
                dstr[5] = (curdispx - dstr[3])                / dstr[1];
                dstr[6] = (curdispy - TASKBARAREA - dstr[4]) /  dstr[2];
                break;
        case 0x7E:      // Function 7E: Get center-pos
                dstr[2] = (curdispx / 2) - (dstr[1] / 2);
                break;
        case 0x7F:      // Function 7F: Get available resolution (1,2,3 = x,y,c)
                dstr[1] = curdispx;
                dstr[2] = curdispy - TASKBARAREA;
                dstr[3] = curdispc;
                break;
        case 0x80:      // Function 80: Get resolution (1,2,3 = x,y,c)
                dstr[1] = curdispx;
                dstr[2] = curdispy;
                dstr[3] = curdispc;
                break;
        case 0x81:      // Function 81: Set resolution (1,2,3 = x,y,c)
                setresext(0,dstr[1],dstr[2],dstr[3]);
                break;
        case 0x82:      // Function 82: Draw something (9 can be 0x1234 to force drawing)
                if((fgtask != runningtask) && (dstr[9] != 0x1234)) break;
                dstr[9] = 0;
                switch(dstr[1])
                        {
                        case 0:         // Function 82/0: Set pixel (2,3,4 = x,y,c)
                                setpixel(dstr[2],dstr[3],dstr[4]);
                                break;
                        case 1:         // Function 82/1: Get pixel (2,3 = x,y; ret: 4=c)
                                dstr[4] = getpixel(dstr[2], dstr[3]);
                                break;
                        case 2:         // Function 82/2: Draw HLINE (2,3,4,5 = y,x1,x2,c)
                                hline(dstr[2],dstr[3],dstr[4],dstr[5]);
                                break;
                        case 3:         // Function 82/3: Draw VLINE (2,3,4,5 = x,y1,y2,c)
                                vline(dstr[2],dstr[3],dstr[4],dstr[5]);
                                break;
                        case 4:         // Function 82/4: Draw RECT (2,3,4,5,6 = x1,y1,x2,y2,c)
                                if(dstr[2] == 0xFFFF)
                                    drawrect(0,0,curdispx-1,curdispy-1-TASKBARAREA,dstr[6]);
                                else
                                    drawrect(dstr[2],dstr[3],dstr[4],dstr[5],dstr[6]);
                                break;
                        case 5:         // Function 82/5: Draw FillRECT (2,3,4,5,6 = x1,y1,x2,y2,c)
                                if(dstr[2] == 0xFFFF)
                                    drawrectf(0,0,curdispx-1,curdispy-1-TASKBARAREA,dstr[6]);
                                else
                                    drawrectf(dstr[2],dstr[3],dstr[4],dstr[5],dstr[6]);
                                break;
                        case 6:         // Function 82/6: Text (2,3,4,5,6,7,8 = x,y,fg,bg,font,seg,off)
                                if(dstr[3] == -1) dstr[3] = curdispy - (1+TASKBARAREA + textheight(dstr[6],MK_FP(dstr[7],dstr[8])));
                                outtext(dstr[2],dstr[3],dstr[4],dstr[5],dstr[6],MK_FP(dstr[7],dstr[8]));
                                break;
                        case 7:         // Function 82/7: Draw sprite (2,3,4,5 = x,y,seg,off)
                                drawsprite(dstr[2],dstr[3],MK_FP(dstr[4],dstr[5]));
                                break;
                        case 8:         // Function 82/8: Draw Button (2,3,4,5,6 = x,y,x2,y2,fillcol)
                                drawbutton(dstr[2], dstr[3], dstr[4], dstr[5], dstr[6]);
                                break;
                        case 9:         // Function 82/9: Draw Buttondown (2,3,4,5,6 = x,y,x2,y2,fillcol)
                                drawbuttondown(dstr[2], dstr[3], dstr[4], dstr[5], dstr[6]);
                                break;
                        case 0xA:       // Function 82/A: Draw Optionbutton (2,3,4 = X,Y,Down)
                                drawoptbtn(dstr[2], dstr[3], dstr[4]);
                                break;
                        case 0xB:       // Function 82/B: Draw Checkbox (2,3,4 = X,Y,Down)
                                drawcheckbox(dstr[2], dstr[3], dstr[4]);
                                break;
                        case 0xC:       // Function 82/C: Draw complete button (2,3,4,5,6,7,8,10,11,12 = X,Y,X2,Y2,Down,Font,FgCol,BgCol,Seg,Off)
                                drawcompletebutton(dstr[2],dstr[3],dstr[4],dstr[5],dstr[6],dstr[7],dstr[8],dstr[10],MK_FP(dstr[11], dstr[12]));
                                break;
                        case 0xD:       // Function 82/D: Draw easybutton (2,3,4,5,6,7 = x,y,fntid,down,seg,off)
                                globfar = MK_FP(dstr[6],dstr[7]);
                                drawcompletebutton(dstr[2],dstr[3],dstr[2] + textwidth(dstr[4],globfar) + 20,dstr[3] + textheight(dstr[4],globfar) + 5,dstr[5],dstr[4],0,7,globfar);
                                break;
                        case 0xE:       // Function 82/E: Paint area (2,3,4,5,6 = x,y,col,seg,off) seg:off=datastruct
                                // Datastruct (UINTS): xnum,ynum,leftspace,upspace,rightspace,downspace
                                globfar = MK_FP(dstr[5],dstr[6]);
                                globa = (curdispx - ((((UINT *) globfar)[2] + ((UINT *) globfar)[4]))) / ((UINT *) globfar)[0];
                                globb = (curdispy - (TASKBARAREA + (((UINT *) globfar)[3] + ((UINT *) globfar)[5]))) / ((UINT *) globfar)[1];
                                globc = globa * dstr[2] + ((UINT *) globfar)[2];
                                globd = globb * dstr[3] + ((UINT *) globfar)[3];
                                drawrectf(globc,globd,globc+globa-1,globd+globb-1,dstr[4]);
                                break;
                        case 0xF:       // Function 82/F: Draw rect around area (2,3,4,5,6 = x,y,col,seg,off) seg:off=datastruct
                                // Datastruct (UINTS): xnum,ynum,leftspace,upspace,rightspace,downspace,fillcol
                                globfar = MK_FP(dstr[5],dstr[6]);
                                globa = (curdispx - ((((UINT *) globfar)[2] + ((UINT *) globfar)[4]))) / ((UINT *) globfar)[0];
                                globb = (curdispy - (TASKBARAREA + (((UINT *) globfar)[3] + ((UINT *) globfar)[5]))) / ((UINT *) globfar)[1];
                                globc = globa * dstr[2] + ((UINT *) globfar)[2];
                                globd = globb * dstr[3] + ((UINT *) globfar)[3];
                                drawrectf(globc+1,globd+1,globc+globa-2,globd+globb-2,((UINT *) globfar)[6]);
                                drawrect(globc,globd,globc+globa-1,globd+globb-1,dstr[4]);
                                break;
                        case 0x10:      // Function 82/10: Draw border around area (2 = color)
                                // Datastruct (UINTS): xnum,ynum,leftspace,upspace,rightspace,downspace
                /* Screen */    globa = (curdispx - ((((UINT *) globfar)[2] + ((UINT *) globfar)[4])));
                                globb = (curdispy - (TASKBARAREA + (((UINT *) globfar)[3] + ((UINT *) globfar)[5])));
                  /* Tile */    globc = globa / ((UINT *) globfar)[0];
                                globd = globb / ((UINT *) globfar)[1];
                                globa = globc * ((UINT *) globfar)[0];
                                globb = globd * ((UINT *) globfar)[1];
                    /*  Left */ drawrectf(((UINT *) globfar)[2],((UINT *) globfar)[3],((UINT *) globfar)[2] + globc - 1, globb - 1,dstr[2]);
                    /*    Up */ drawrectf(((UINT *) globfar)[2],((UINT *) globfar)[3], globa - 1, globd - 1, dstr[2]);
                    /* Right */ drawrectf(globa - globc, ((UINT *) globfar)[3], globa - 1, globb - 1, dstr[2]);
                    /*  Down */ drawrectf(((UINT *) globfar)[2], globb - globd, globa - 1, globb - 1, dstr[2]);
                                break;
                        case 0x11:      // Function 82/11: Repaint GUI
                                gui_repaint(runningtask);
                                break;
                        case 0x12:      // Function 82/12: Check for clicks (2 = x; 2=(ID for guiele)/(255=Nothing)/(x=Not fg.task)
                                dstr[2] = gui_checkclick(runningtask);
                                break;
                        case 0x13:      // Function 82/13: Get 8-Bit Bitmap (2,3,4,5,6,7 = x,y,xsize,ysize,seg,off)
                                getarea256(dstr[2],dstr[3],dstr[4]+dstr[2],dstr[5]+dstr[3],MK_FP(dstr[6],dstr[7]));
                                break;
                        case 0x14:      // Function 82/14: Put 8-Bit Bitmap (2,3,4,5,6,7 = x,y,xsize,ysize,seg,off)
                                setarea256(dstr[2],dstr[3],dstr[4]+dstr[2],dstr[5]+dstr[3],MK_FP(dstr[6],dstr[7]));
                                break;
                        }
                break;
        case 0x83:  // Function 83: Add-GUIElement (1,2 = Parablock ; 3=Handle/255:Error)
                // Parablock: eletype,x1,y1,x2,y2,seg,off,font,bg,fg,addit,addit2
                globfar = MK_FP(dstr[1],dstr[2]);
                dstr[3] = gui_createsomething(((UINT *) globfar)[0], ((UINT *) globfar)[1], ((UINT *) globfar)[2], ((UINT *) globfar)[3], ((UINT *) globfar)[4], MK_FP(((UINT *) globfar)[5],((UINT *) globfar)[6]), ((UINT *) globfar)[7], ((int *) globfar)[8], ((int *) globfar)[9], ((UINT *) globfar)[10], ((UINT *) globfar)[11], runningtask);
                break;
        case 0x84:  // Function 84: Remove-GUIElement (1=Handle ; 2=(0:OK, 1:Not owner))
                dstr[2] = gui_freehandle(dstr[1], runningtask);
                break;
        case 0x85:  // Function 85: Get mouse (; 1,2,3=X,Y,but)
                dstr[1] = mousex;
                dstr[2] = mousey;
                dstr[3] = butti;
                break;
        case 0x86:  // Function 86: Set temp-resolution (1,2,3 = X(0=restore),Y,C ; 4=(0:OK 1:ERROR))
                if(dstr[1] == 0)
                    {
                    dstr[4] = setres(0);
                    tasktable[runningtask].xres = 0;
                    }
                else
                    {
                    dstr[4] = setresext(0,dstr[1],dstr[2],dstr[3]);
                    if(dstr[4] == 0)
                        {
                        tasktable[runningtask].xres = dstr[1];
                        tasktable[runningtask].yres = dstr[2];
                        tasktable[runningtask].cres = dstr[3];
                        }
                    }
                break;
        }
    }

void removedrivers(void)
    {
    UINT freesegs[256];
    UCHR dcnt=0;
    UCHR i;
    union REGS ioreg;
    struct SREGS ioseg;

    puts("Ulsop-Kernel: Getting Driver-memory");
    for(i=0;i!=255;i++)
        {
        ioreg.h.ah = i;
        ioreg.h.al = 0xFF;
        ioreg.x.si = 0x00;
        int86(0xFD,&ioreg,&ioreg);
        if(ioreg.x.si == 0x1234)
            {
            if(ioreg.x.ax != 0) freesegs[dcnt++] = ioreg.x.ax;
            if(ioreg.x.bx != 0) freesegs[dcnt++] = ioreg.x.bx;
            if(ioreg.x.cx != 0) freesegs[dcnt++] = ioreg.x.cx;
            if(ioreg.x.dx != 0) freesegs[dcnt++] = ioreg.x.dx;
            }
        }

    puts("Ulsop-Kernel: Freeing Driver-Memory");
    for(i=0;i<dcnt;i++)
        {
        ioreg.h.ah = 0x49;
        ioseg.es = freesegs[i];
        int86x(0x21,&ioreg,&ioreg,&ioseg);
        }
    }

void main()
    {
    UINT i,j,k,l,m;
    UCHR loci,cj,ck,cl;

    FILE *fp,*fp2;
    char astr[81];
    char *aptr;
    char sstr[5];
        // At first we have to set up the service-Interrupt
//-
    puts("------ " ULSOP_VERSIONSTR " booting ------");

#ifdef MOUSEDBG
mousedbg = fopen("mousedeb.txt","w");
#endif

    *((UCHR *) NULL) = '\0';
    cleartasktable();
    puts("Ulsop: Initalizing services");
    setvect(0xFF, &ulhandle);       // Setting Servicehandler
    setvect(0xFB, &swtask);         // Taskswitcher
    _asm
        {
        mov ax, 25FEh
        mov dx, OFFSET dstr
        int 21h                     // Pseudo-Int FEh Points to Param-Struct

        mov ax, 25FCh
        mov dx, OFFSET iretdata     // Pointer to an IRET
        int 21h

        mov ax, 25FDh
        mov dx, OFFSET iretdata     // Pointer to an IRET (chaining)
        int 21h

        mov ax, cs
        mov mycs, ax
        mov ax, ds
        mov myds, ax
        }
//-
    puts("Ulsop-Kernel: Loading INI-File");
    loadini();
//    srand(atoi(getentry("RANDOMIZER")));
//-
    puts("Ulsop-Kernel: Loading Device-Drivers");
    if((fp = fopen("drivers.uss","r")) == NULL)
        {
        puts("ERROR! No driverfile found.");
        puts("Ulsop won't run without drivers!");
        goto crashdos;
        }
     j = 0;
     while(fgets(astr,80,fp) != NULL)
        {
        aptr = astr;
        while((*aptr != '\n') && (*aptr != '\0'))
            aptr++;
        *aptr = 0;

        dstr[0] = j;
        printf("dstr[0] = %i ; runprg(\"%s\") =",j++,astr);
        printf(" %u\n",runprg(astr));
        }
    fclose(fp);
//-
    puts("Ulsop-Kernel: Scanning for display-drivers");
    i = 0;
    for(ck=0;ck!=255;ck++)
        {
        printf("%u/255\r",ck);
        _asm
            {
            mov ah, ck
            mov al, 0   // Fkt.0 - Get ID
            int 0FDh
            mov loci, ah
            mov cj, al
            }
        if(loci == 0)    // Disp.Driver?
            {
            for(loci=0;loci<cj;loci++)    // Get through all modes
                {
                _asm
                    {
                    mov ah, ck
                    mov cl, loci
                    mov al, 1
                    int 0FDh
                    mov k, ax
                    mov l, bx
                    mov m, cx
                    }
                printf("%u: %u x %u x %u - sup. by ",(UINT) i,(UINT) k,(UINT) l,(UINT) m);
                printf("%u,%u\n",(UINT) ck,(UINT) loci);
                dismodes[i].xres = k;
                dismodes[i].yres = l;
                dismodes[i].cdeep = m;
                dismodes[i].drivnum = ck;
                dismodes[i++].modeid = loci;
                }
            }
        }
    puts("Enumeration complete.");
    if(i == 0)
        {
        puts("No Display-Driver found!");
        puts("Ulsop won't run without such a thing");
        goto delcrashdos;
        }

    puts("Ulsop-Kernel: Loading fonts");
    j = 0;
    if((fp = fopen("fonts.uss","r+")) == NULL)
        {
        puts("ERROR! No fontfile found.");
        puts("Ulsop won't run without fonts!");
        goto delcrashdos;
        }
     while(fgets(astr,80,fp) != NULL)
        {
        aptr = astr;
        while((*aptr != '\n') && (*aptr != '\0'))
            aptr++;
        *aptr = 0;

        printf("Loading %s: ",astr);
        if(j > 15)
                puts("ERROR! Font-Table full");
        else
                if((fp2 = fopen(astr,"rb")) == NULL)
                        puts("ERROR! File not found.");
                else
                        {
                        printf("Reading ");
                        fseek(fp2,0,SEEK_END);
                        k = ftell(fp2);
                        fseek(fp2,0,SEEK_SET);
                        printf("%i Bytes ",k);
                        if((fonttab[j] = malloc(k+1)) == NULL)
                                puts("ERROR! Not enough memory");
                        else
                                {
                                fread(fonttab[j],k,1,fp2);
                                fonttab[j][k] = 0;
                                puts("OK");
                                j++;
                                }
                        fclose(fp2);
                        }
        }
    fclose(fp);
    searchmouse();

    sleep(2);

    if(setres(1)) goto delcrashdos;

    getmousestatus(&mousex, &mousey, &globa);       // Ignore buttons
    if(mousex != 0xFFFF) mousepointeron = 1;
//-
    drawthetaskbar();

    runuxe("osloader.uxe");

    showhidecursor(1);
    puts("Ulsop-Kernel: Wait while loading Multitasking-Environment....");
    runprg("ulmulti.com");
    if(strkill) exit(1);
    _asm
        {
        mov ax, 25FCh
        mov dx, OFFSET iretdata     // Pointer to an IRET
        int 21h
        }
//    if((i = getreturncode()) == 0)
//        {
        xedown:
        removedrivers();
        puts("\n\n\nUlsop shutdown complete.\n");
        puts("You can do the following:");
        puts(" Switch the computer OFF");
        puts(" Press Ctrl+Alt+Del");
        puts(" Press Enter to return to DOS");
        getchar();
        exit(0);
//        }
//    else
//        {
        xeerrormulti:
        removedrivers();
        goto crashdos;
        puts("ERROR loading Multitasking-Environment\a");
        delcrashdos:
        removedrivers();
        crashdos:
        puts("You will crash back to DOS");
        exit(1);
//        }
    }
