// Mousedriver-Access

// Function 0 - ?
//  Out: AH=01h (Ident. Mousedrivers)
//  Out: BX=Mousebuttons
//  Out: CX=3210h
//  Out: DL=(0:Pointer by driver; <>0:Software pointer)

// Function 1 - Show Cursor
// Function 2 - Hide Cursor
showhidecursor(int showme);

// Function 3 - Get X,Y and Buttons
//  Out: BX=Buttonbyte
//  Out: CX=X-Position
//  Out: DX=Y-Position
void getmousestatus(UINT *x, UINT *y, UINT *btn);

// Function 4 - Set Cursor-Pos
//  In: CX=X-Position
//  In: DX=Y-Position
void setmousestatus(UINT x, UINT y);

// Function 5 - Set Cursor
//  In: BX=X-Hotspot
//  In: CX=Y-Hotspot
//  In: DX=Offset
//  In: ES=Segment
void setmousecursor(UINT xhot, UINT yhot, char far *mask);

UCHR mouseid=0xFF;
UINT mousebtns=0;

char mptr[] = "A\nAA\nAKA\nAKKA\nAKKKA\nAKKKKA\nAKKKKKA\nAKKKKKKA\nAKKKKKKKA\nAKKKKKKKKA\nAKKKKKAAAAA\nAKKAKKA\nAKA AKKA\nAA  AKKA\nA    AKKA\n     AKKA\n      AKKA\n      AKKA\n       AA";
unsigned char mbuf[209];
char manmouse=0, manmouseon=0;
int lamx=-1, lamy=-1;

void domouse()
    {
    UCHR yxz=mousepointeron;
    mousepointeron = 0;

    if(lamx == mousex && lamy == mousey) return;

    #ifdef MOUSEDBG
    fprintf(mousedbg,"Drawing mouse cur=%i,%i last=%i,%\n",mousex,mousey,lamx,lamy);
    #endif

    if(lamx != -1) setarea256(lamx, lamy, lamx + 11, lamy + 19, mbuf);
    lamx = mousex; lamy = mousey;
    if(manmouseon)
        { 
        getarea256(lamx, lamy, lamx + 11, lamy + 19, mbuf);
        drawsprite(lamx,lamy,mptr);
        }
    else
        lamx=-1; 

    mousepointeron = yxz;
    }

void searchmouse()
    {
    int i;
    puts("Ulsop-Kernel: Looking for a mouse");
    for(i=0;i<255;i++)
        {
        printf("%i/255\r",i);
        _asm
            {
            mov ax, i
            mov ah, al
            xor al, al
            int 0FDh
            cmp cx, 3210h
            jnz isnomouse
            mov mousebtns, bx
            mov manmouse, dl
            jz amousefnd
            isnomouse:
            }
        }
    puts("No mouse found");
    return;
amousefnd:
    printf("Found a mouse with %i Buttons @ driver %i, %s-controlled\n",mousebtns,i,manmouse ? "kernel" : "driver");
    mouseid = i;
    }

showhidecursor(int showme)
    {
    #ifdef MOUSEDBG
    fprintf(mousedbg,"Setting mousestatus to %i\n",showme);
    #endif
    
    if(manmouse)
        {
        manmouseon = showme;
//        printf("Manualmouse switched o%s\n", manmouseon ? "n" : "ff");
        domouse();
        return;
        }

    if(mouseid == 0xFF) return;

//    printf("Driver mouse changed");

    if(showme) showme = 1; else showme = 2;
    _asm
        {
        mov ax, showme
        mov ah, mouseid
        int 0FDh
        }
    }

void getmousestatus(UINT *x, UINT *y, UINT *btn)
    {
    int ar,br,cr;
    if(mouseid == 0xFF)
        ar=(br=(cr=0xFFFF));
    else
      _asm
        {
        mov ah, mouseid
        mov al, 3
        int 0FDh
        mov ar, bx
        mov br, cx
        mov cr, dx
        }
    *x = br; *y = cr; *btn = ar;
    }

void setmousestatus(UINT x, UINT y)
    {
    if(mouseid == 0xFF) return;
    _asm
        {
        mov ah, mouseid
        mov al, 4
        mov cx, x
        mov dx, y
        int 0FDh
        }
    }

void setmousecursor(UINT xhot, UINT yhot, char far *mask)
    {
    UINT mseg=FP_SEG(mask), moff=FP_OFF(mask);
    if(mouseid == 0xFF) return;
    _asm
        {
        mov es, mseg
        mov ah, mouseid
        mov al, 5
        mov bx, xhot
        mov cx, yhot
        mov dx, moff
        int 0FDh
        }
    }

