#include "string.h"

struct aninientry
    {
    char *keyname;
    char *keydata;
    struct aninientry *nextone;
    } *inianchor;

void loadini()
    {
    FILE *fp;
    char *aptr;
    char astr[201];
    struct aninientry *ladptr;
    unsigned i;

    if((fp = fopen("ulsop.ini","r")) == NULL)
        {
        puts("ERROR: Cannot load ULSOP.INI");
        noini:
        puts("INI-Services won't be enabled in this session");
        inianchor = NULL;
        }
    else
        {
        inianchor = malloc(sizeof(struct aninientry));
        if(inianchor == NULL)
            {
            puts("Not enough memory");
            goto noini;
            }
        inianchor->keyname = "VERSION";
        inianchor->keydata = ULSOP_VERSIONSTR;
        inianchor->nextone = NULL;
        ladptr = inianchor;
        while(fgets(astr,200,fp) != NULL)
            {              
            aptr = astr;
            while(*aptr != '\n')
                aptr++;
            *aptr = 0;

            if((ladptr->nextone = malloc(sizeof(struct aninientry))) == NULL)
                {
                xeinicrop:
                ladptr->nextone = NULL;
                puts("Not enough memory, ULSOP.INI cropped");
                fclose(fp);
                return;
                }
            ladptr = ladptr->nextone;

            aptr = strchr(astr,'=');
            if(aptr == NULL)
                {
                printf("Error in INI-String: \"%s\",using \"TRUE\"\n",astr);
                ladptr->keyname = strdup(astr);
                ladptr->keydata = strdup("TRUE");
                }
            else
                {
                *aptr=0;
                ladptr->keyname = strdup(astr);
                if(ladptr->keyname == NULL) goto xeinicrop;
                ladptr->keydata = strdup(aptr+1);
                if(ladptr->keydata == NULL) goto xeinicrop;
                }
            }
        ladptr->nextone = NULL;
        fclose(fp);
        }    
    }    

char saveini()      // 0=OK
    {
    FILE *fp;
    struct aninientry *savptr;
    if(inianchor != NULL)
        if((fp = fopen("ULSOP.INI","w")) == NULL)
            return 1;
        else
            {
            savptr = inianchor;
            while(savptr != NULL)
                {
                fprintf(fp,"%s=%s\n",savptr->keyname,savptr->keydata);
                savptr = savptr->nextone;
                }
            fclose(fp);
            }
    return 0;
    }

char setentry(char *keyname, char *keydata)
    {
    struct aninientry *savptr, *asptr;
    savptr = inianchor;
    while(savptr != NULL)
        {
        if(!strcmp(savptr->keyname,keyname))
            {
            free(savptr->keydata);
            savptr->keydata = strdup(keydata);
            }
        asptr = savptr;
        savptr = savptr->nextone;
        }
    if((savptr = malloc(sizeof(struct aninientry))) == NULL) return 1;
    asptr->nextone = savptr;
    savptr->keyname = strdup(keyname);
    savptr->keydata = strdup(keydata);
    return 0;
    }

char *getentry(char *keyname)
    {
    struct aninientry *savptr;
    savptr = inianchor;
    while(savptr != NULL)
        {
        if(!strcmp(savptr->keyname,keyname))
            return savptr->keydata;
        savptr = savptr->nextone;
        }
    return NULL;
    }

void outini()
    {
    struct aninientry *savptr;
    savptr = inianchor;
    while(savptr != NULL)
        {
        printf("\"%s\"=\"%s\"\n",savptr->keyname,savptr->keydata);
        savptr = savptr->nextone;
        }
    }
